#!/bin/sh
### -*- mode:shell-script; indent-tabs-mode:nil; sh-basic-offset:2 -*-
### BEGIN INIT INFO
# Provides: freeswitch
# Required-Start: $network $remote_fs $local_fs
# Required-Stop: $network $remote_fs $local_fs
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: FreeSWITCH Softswitch
# Description: FreeSWITCH Softswitch
### END INIT INFO

# Author: Travis Cross <tc@traviscross.com>

PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC=freeswitch
NAME=freeswitch
DAEMON=/usr/bin/freeswitch
USER=freeswitch
GROUP=freeswitch
TUTDIR=/usr/share/cgrates/tutorials/fs_evsock/freeswitch
SCRIPTNAME=$TUTDIR/etc/init.d/$NAME
TMP_DIR=/tmp/cgr_fsevsock/freeswitch
CONFDIR=$TUTDIR/etc/$NAME
RUNDIR=$TMP_DIR/run
LOGDIR=$TMP_DIR/log
PIDFILE=$RUNDIR/$NAME.pid
WORKDIR=$TMP_DIR/lib
DBDIR=$WORKDIR/db/
DAEMON_ARGS="-rp -conf $CONFDIR -db $DBDIR -log $LOGDIR -u $USER -g $GROUP -nonat -nc"


[ -x $DAEMON ] || exit 0
. /lib/init/vars.sh
. /lib/lsb/init-functions

if [ ! -d $RUNDIR ]; then
  mkdir -p $RUNDIR
  chown -R $USER:$GROUP $RUNDIR
  chmod -R ug=rwX,o= $RUNDIR
fi

if [ ! -d $LOGDIR ]; then
  mkdir -p $LOGDIR
  chown -R $USER:$GROUP $LOGDIR
fi

if [ ! -d $DBDIR ]; then
  mkdir -p $DBDIR
  chown -R $USER:$GROUP $DBDIR
fi

do_start() {
  if ! [ -f $CONFDIR/freeswitch.xml ]; then
    echo "$NAME is not configured so not starting.">&2
    echo "Please review /usr/share/doc/$NAME/README.Debian">&2
    return 3
  fi
  echo $DAEMON_ARGS
  start-stop-daemon --start --quiet \
    --pidfile $PIDFILE --exec $DAEMON --name $NAME --user $USER \
    --test > /dev/null \
    || return 1
  ulimit -s 240
  start-stop-daemon --start --quiet \
    --pidfile $PIDFILE --exec $DAEMON --name $NAME --user $USER \
    --chdir $WORKDIR -- $DAEMON_ARGS $DAEMON_OPTS \
    || return 2
  return 0
}

stop_fs() {
  start-stop-daemon --stop --quiet \
    --pidfile $PIDFILE --name $NAME --user $USER \
    --retry=TERM/30/KILL/5
}

stop_fs_children() {
  start-stop-daemon --stop --quiet \
    --exec $DAEMON \
    --oknodo --retry=0/30/KILL/5
}

do_stop() {
  stop_fs
  RETVAL="$?"
  [ "$RETVAL" -eq 2 ] && return 2
  stop_fs_children
  [ "$?" -eq 2 ] && return 2
  rm -f $PIDFILE
  return "$RETVAL"
}

do_reload() {
  start-stop-daemon --stop --quiet \
    --pidfile $PIDFILE --name $NAME --user $USER \
    --signal HUP
}

case "$1" in
  start)
    [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME"
    do_start
    case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
    esac
    ;;
  stop)
    [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
    do_stop
    case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
    esac
    ;;
  status)
    status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
    ;;
  reload|force-reload)
    log_daemon_msg "Reloading $DESC" "$NAME"
    do_reload
    log_end_msg $?
    ;;
  restart)
    log_daemon_msg "Restarting $DESC" "$NAME"
    do_stop
    case "$?" in
      0|1)
        do_start
        case "$?" in
          0) log_end_msg 0 ;;
          1|*) log_end_msg 1 ;;
        esac
        ;;
      *) log_end_msg 1 ;;
    esac
    ;;
  *)
    echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
    exit 3
    ;;
esac

exit 0
